<template>
  <section class="flex items-center gap-2">
    <v-btn
      prepend-icon="mdi-plus"
      class="text-teal-600"
      variant="tonal"
      rounded
      @click="onCreateClick"
    >
      Добавить
    </v-btn>

    <v-btn
      class="cursor-help"
      color="gray"
      variant="plain"
      :ripple="false"
    >
      <section class="flex items-center">
        <v-icon
          icon="mdi-help-circle-outline"
          size="large"
        />

        <span class="ml-[2px]">Подробнее</span>
      </section>

      <v-tooltip
        activator="parent"
        location="bottom"
        open-on-click
      >
        Вы можете ввести любые коррекции, которые будут применены <br>
        к итоговой стоимости
        <br>

        Это может быть скидка, штраф, уточнение
        или что угодно, что необходимо учесть при создании бронирования
        <br>

        Поддерживаются отрицательные значения
      </v-tooltip>
    </v-btn>
  </section>

  <v-scroll-y-transition leave-absolute>
    <section
      v-if="corrections.length"
      class="py-4"
    >
      <v-scroll-y-transition group>
        <CorrectionItem
          v-for="(correction, index) in corrections"
          :key="correction.id"
          :data="correction"
          :class="{ 'bg-gray-100': index % 2 === 0 }"
          @update="onCorrectionUpdate"
          @delete="onCorrectionDelete"
        />
      </v-scroll-y-transition>
    </section>
  </v-scroll-y-transition>

  <section
    v-if="!corrections.length"
    class="bg-gray-50 mt-4 py-8"
  >
    <EmptyState embedded />
  </section>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { nanoid } from 'nanoid';

import EmptyState from '@/components/layout/EmptyState.vue';
import CorrectionItem from './CorrectionItem.vue';

const props = defineProps<{ modelValue: IProfitCorrection[] }>();
const emit = defineEmits(['update:modelValue']);

const corrections = ref<IProfitCorrection[]>(props.modelValue);

const updateModelValue = () => {
  const result = corrections.value.map(({ id, value, reason }) => ({
    reason: reason.trim(),
    value,
    id,
  }));

  emit('update:modelValue', result);
};

const onCreateClick = () => {
  corrections.value.push({ id: nanoid(), value: 0, reason: '' });
};

const onCorrectionUpdate = (data: IProfitCorrection) => {
  const targetCorrection = (
    corrections.value.find(({ id }) => id === data.id)
  );

  if (!targetCorrection) {
    return;
  }

  targetCorrection.value = data.value;
  targetCorrection.reason = data.reason;

  updateModelValue();
};

const onCorrectionDelete = (targetId: string) => {
  const targetCorrectionIndex = (
    corrections.value.findIndex(({ id }) => id === targetId)
  );

  if (targetCorrectionIndex < 0) {
    return;
  }

  corrections.value.splice(targetCorrectionIndex, 1);
  updateModelValue();
};
</script>